#!/bin/sh
#
#Script para arrancar SomaD (el demonio de emision).
# (le he cambiado el nombre (antes arrancar-somad.sh) para evitar interferencias en ps).
# Necesita los comandos standar ps, grep y killall, y ademas Xdialog, rxvt y somad. 
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Comprobar los procesos arrancados que puedan dar problemas:
PROCESS=`ps -e | egrep -o -i 'esd|somad|somax|soma|mplayer|gmusicbrowser|xmms|aqualung'`
if [ "$PROCESS" != "" ];then
  Xdialog --wmclass "soma" --title "Arrancar SomaD" --default-no --left --ok-label "Matar procesos" --cancel-label "NO matar procesos" \
  --backtitle "Encuentro los siguientes \"programas\" arrancados que impiden arrancar SomaD con normalidad\n(aunque es posible que tu no puedas ver sus ventanas): ""$PROCESS""." \
  --yesno "Mira todas las ventanas que hay abiertas (estarn en la barra de tareas inferior).\n\nSi NO encuentras ninguna abierta que tenga nada que ver con el sonido\n(algn programa de los listados arriba, por ejemplo),\n entonces dale a \"Matar procesos\" en esta ventana\n(y despues arranca SomaD en la siguiente).\n\nSi SI que hay alguna de esas abierta, puedes hacer dos cosas\n(depender de por que estan abiertas):\n - Cerrar todos esos programas y despues dar a \"NO matar procesos\"\n      para continuar con el arranque normal de SomaD.\n - Mantener ese/esos programa(s) abierto y no arrancar Somad,\n      dando a \"NO matar procesos\" aqui, y despues en la siguiente ventana,\n      a \"Cancelar\" para no arrancar SomaD" 0 0
    #Si respuesta es SI (matar procesos) = 0: Si respuesta es NO (no matarlos) = 1
    case $? in
     0)
      killall -s KILL $PROCESS;;
     1)
      ;;
    esac
fi

#GUI con la pregunta de si arrancar somad o no:
Xdialog --wmclass "soma" --title "Arrancar SomaD" --default-no \
        --backtitle "Arrancar SomaD (el programa que emite)?." \
       --yesno "(Utilizar solamente si est COMPLETAMENTE parado, no en pausa)." 0 0

#Si respuesta es SI: arranca somad en una rxvt
#Si respuesta es NO: sale sin hacer nada
case $? in
  0)
    rxvt +sb -e somad;;
  1)
    exit;;
esac
